#include "Connector.h"
namespace mdd {

	bool Connector::contains_subj_obj_structure(const json& args) {
		if (args.contains("object") && args.contains("subject"))
		{
			return true;
		}

		return false;
	}

	json Connector::add(const json& args) {
		json ret;
		if (!contains_subj_obj_structure(args))
		{
			return ret;
		}
		json sub = args["subject"];
		if (!sub.contains("type"))
		{
			return ret;
		}
		ret["operation"] = "add";
		json jargs;
		if (sub["type"] == "processor")
		{
			jargs["subject"] = _root->getIdentifier();
		}
		else if(sub["type"] == "module")
		{

		}

		else {
			json j;
			return j;
		}

		json obj = args["object"];
		if (!obj.contains("type"))
		{
			json j;
			return j;
		}
		if (obj["type"] == "processor")
		{

		}
		else if (obj["type"] == "module")
		{
			_root->addModule(Registration().generateModule(obj["key"].get<std::string>()));
			jargs["object"] = _root->getModules().back()->dump();
		}
		else if (obj["type"] == "connection")
		{
			IModule::Ptr module_in_ptr = _root->getModule(obj["input"]["prefix"].back().get<std::string>());
			IModule::Ptr module_out_ptr = _root->getModule(obj["output"]["prefix"].back().get<std::string>());
			if (module_in_ptr != nullptr && module_out_ptr != nullptr) {
				IInput::Ptr in_ptr = nullptr;
				std::string id = obj["input"]["name"].get<std::string>() + std::to_string(obj["input"]["appendix"].get<int>());
				for (size_t i = 0; i < module_in_ptr->getNumInputs(); i++)
				{
					auto in = module_in_ptr->getInput(i);
					if (in->getID() == id)
					{
						in_ptr = in;
						break;
					}
				}

				IOutput::Ptr out_ptr = nullptr;
				id = obj["output"]["name"].get<std::string>() + std::to_string(obj["output"]["appendix"].get<int>());
				for (size_t i = 0; i < module_out_ptr->getNumOutputs(); i++)
				{
					auto out = module_out_ptr->getOutput(i);
					if (out->getID() == id)
					{
						out_ptr = out;
						break;
					}
				}

				if (in_ptr != nullptr && out_ptr != nullptr)
				{
					in_ptr->connect(out_ptr);
					jargs["object"] = obj;
				}
				
			}
			
			
		}
		else if (obj["type"] == "input")
		{

		}
		else if (obj["type"] == "output")
		{

		}
		else if (obj["type"] == "configuration")
		{

		}
		else {
			return ret;
		}
		ret["args"] = jargs;
		return ret;
	}

	json Connector::remove(const json& args) {

		return args;
	}

	json Connector::change(const json& args) {
		json ret;
		if (!contains_subj_obj_structure(args))
		{
			return ret;
		}
		json sub = args["subject"];
		if (!sub.contains("type"))
		{
			return ret;
		}
		json obj = args["object"];
		ret["operation"] = "change";
		json jargs;
		if (sub["type"] == "processor")
		{
			if (jargs["subject"] == _root->getIdentifier())
			{
				jargs["subject"] = _root->getIdentifier();
				if (_root->configure(obj.dump()))
				{
					jargs["object"] = obj;
				}
			}
			else
			{
				IModule::Ptr module_ptr = _root->getModule(sub["name"].get<std::string>() + std::to_string(sub["appendix"].get<int>()));
				if (module_ptr == nullptr) {
					std::cout << "[Connector]: change: Was not able to find module." << std::endl;
					return ret;
				}
				jargs["subject"] = module_ptr->getIdentifier();
				module_ptr->configure(obj.dump());
				if (obj.contains("configure"))
				{
					jargs["object"]["configure"] = module_ptr->dump();
				}
				else {
					jargs["object"] = obj;
				}
				
			}
		}
		else if (sub["type"] == "module")
		{
			IModule::Ptr module_ptr = _root->getModule(sub["name"].get<std::string>() + std::to_string(sub["appendix"].get<int>()));
			if (module_ptr == nullptr) {
				std::cout << "[Connector]: change: Was not able to find module." << std::endl;
				return ret;
			}
			jargs["subject"] = module_ptr->getIdentifier();
			module_ptr->configure(obj.dump());
			if (obj.contains("configure"))
			{
				jargs["object"]["configure"] = module_ptr->dump();
			}
			else {
				jargs["object"] = obj;
			}
		}
		else if (sub["type"] == "input")
		{
			IModule::Ptr module_ptr = _root->getModule(sub["prefix"].back().get<std::string>());
			if (module_ptr == nullptr) {
				std::cout << "[Connector]: change: Was not able to find module." << std::endl;
				return ret;
			}
			IInput::Ptr in_ptr = module_ptr->getInput(sub["name"].get<std::string>() + std::to_string(sub["appendix"].get<int>()));
			if (in_ptr == nullptr) {
				std::cout << "[Connector]: change: Was not able to find input." << std::endl;
				return ret;
			}
			if (obj.contains("value"))
			{
				json jval = json::parse(obj["value"].get<std::string>());
				if (!jval.is_array())
				{
					return ret;
				}
				jval.get<std::vector<double>>();
				std::vector<double> new_val = jval.get<std::vector<double>>();
				in_ptr->setValue(new_val);
				jargs["subject"] = in_ptr->getIdentifier();
				jargs["object"] = obj;
			}
		}
		else if (sub["type"] == "output")
		{

		}
		else {
			json j;
			return j;
		}
		ret["args"] = jargs;
		return ret;
	}

	json Connector::state(const json& args) {
		json j;
		bool found = false;
		if (args == "all")
		{
			j = encode();
		}
		if (args.contains("module"))
		{
			found = true;
			if (args["module"] == "all")
			{
				
				auto modules = regi.getModules();
				for (size_t i = 0; i < modules.size(); i++)
				{
					json jmodule;
					jmodule["key"] = modules[i];
					jmodule["type"] = "module";
					j["module"].push_back(jmodule);
				}
			}
		}
		if (args.contains("processor"))
		{
			found = true;
			if (args["processor"] == "all")
			{
				auto processors = regi.getProcessors();
				for (size_t i = 0; i < processors.size(); i++)
				{
					json jprocessor;
					jprocessor["key"] = processors[i];
					jprocessor["type"] = "module";
					j["processor"].push_back(jprocessor);
				}
			}
		}
		if (!found)
		{
			j["error"] = "Reached end of state parser!";
		}
		//std::cout << "[Connector]: state: " << j.dump() << std::endl;
		json ret;
		ret["operation"] = "state";
		ret["args"] = j;
		return ret;
	}

	Connector::Connector()
	{
		_root = regi.generateProcessor("ProcessorStandard");
		_root->setName("root");
	}

	json Connector::decode(const json& request)
	{
		json ret;

		// check for correct structure
		if (!request.contains("operation") || !request.contains("args")) {
			ret["error"] = "Missing json member!";
			std::cout << "[Connector]: " << "Missing json member!" << std::endl;
			return ret;
		}
		
		auto it = _ops.find(request["operation"].get<std::string>());
		if (it != _ops.end())
		{
			ret = it->second(request["args"]);
			//std::cout << "[Connector]: " << ret.dump() << std::endl;
			return ret;
		}
		ret["error"] = "Operation is not supported!";
		return ret;
	}

	json  Connector::encode()
	{
		json ret;
		ret = _root->dump();
		std::cout << "[Connector]: encode: " << ret.dump() << std::endl;
		return ret;
	}

}

